// Code generated by protoc-gen-defaults. DO NOT EDIT.

package authorpb

import "context"

import "github.com/golang/protobuf/ptypes/empty"
import "go.uber.org/fx"
import "go.appointy.com/events/example/pb/events"

import "deployment/pb/users"

type NotificationEvent string

const ()

/*
	Receiving usage :

	switch (NotificationEvent(event.EventType)){






	        }
*/

type EventsAuthorsServer struct {
	AuthorsServer
	eventsCli events.EventValidatorsClient
	user      users.UserIDer
}

type EventsAuthorsClientResult struct {
	fx.Out
	AuthorsClient AuthorsClient `name:"r"`
}

func NewEventsAuthorsClient(c events.EventValidatorsClient, s AuthorsServer, u users.UserIDer) EventsAuthorsClientResult {
	return EventsAuthorsClientResult{AuthorsClient: NewLocalAuthorsClient(NewEventsAuthorsServer(c, s, u))}
}
func NewEventsAuthorsServer(c events.EventValidatorsClient, s AuthorsServer, u users.UserIDer) AuthorsServer {
	return &EventsAuthorsServer{
		s,
		c,
		u,
	}
}

func (s *EventsAuthorsServer) CreateAuthor(ctx context.Context, eventsvar *CreateAuthorRequest) (*Author, error) {

	res, err := s.AuthorsServer.CreateAuthor(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsAuthorsServer) GetAuthor(ctx context.Context, eventsvar *GetAuthorRequest) (*Author, error) {

	res, err := s.AuthorsServer.GetAuthor(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsAuthorsServer) UpdateAuthor(ctx context.Context, eventsvar *UpdateAuthorRequest) (*empty.Empty, error) {

	res, err := s.AuthorsServer.UpdateAuthor(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsAuthorsServer) DeleteAuthor(ctx context.Context, eventsvar *DeleteAuthorRequest) (*empty.Empty, error) {

	res, err := s.AuthorsServer.DeleteAuthor(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsAuthorsServer) ListAuthor(ctx context.Context, eventsvar *ListAuthorsRequest) (*ListAuthorsResponse, error) {

	res, err := s.AuthorsServer.ListAuthor(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}
